:- module(aci_basics,
	[flatten_aci/2,
	 flatten_sets/2,
	 keys_and_values/3,
	 variant/2]).

:- ensure_loaded([library(ordsets), library(lists)]).

flatten_sets([],[]).
flatten_sets([T|Ts],[FT|FTs]) :- flatten_aci(T,FT), flatten_sets(Ts,FTs).

flatten_aci(L,LF) :- colterms(L,[],TL), sort(TL,LF).

colterms(V,I,O) :- var(V), !, O = [V|I].
colterms([],I,O) :- !, O = I.
colterms([X|Xs],I,O) :- !, colterms(X,I,XI), colterms(Xs,XI,O).
colterms(T,I,O) :-
	(T=..[N,Arg] ->			% constant or unary function?
	 flatten_aci(Arg,ArgF), TF=..[N,ArgF], O = [TF|I]
	  ;
	 O = [T|I]).			% otherwise collect it


keys_and_values([],[],[]).
keys_and_values([K-V|KVs],[K|Ks],[V|Vs]) :- keys_and_values(KVs,Ks,Vs).

variant(A,B) :- \+ \+ (numbervars(A,0,N), numbervars(B,0,N), A=B).

